# -*- coding: utf-8; -*-
"""
Sideshow web app
"""

from wuttaweb import app as base


def main(global_config, **settings):
    """
    Make and return the WSGI app (Paste entry point).
    """
    # prefer Sideshow templates over wuttaweb
    settings.setdefault('mako.directories', [
        'sideshow.web:templates',
        'wuttaweb:templates',
    ])

    # make config objects
    wutta_config = base.make_wutta_config(settings)
    pyramid_config = base.make_pyramid_config(settings)

    # bring in the rest of Sideshow
    pyramid_config.include('sideshow.web.static')
    pyramid_config.include('sideshow.web.subscribers')
    pyramid_config.include('sideshow.web.views')

    return pyramid_config.make_wsgi_app()


def make_wsgi_app():
    """
    Make and return the WSGI app (generic entry point).
    """
    return base.make_wsgi_app(main)


def make_asgi_app():
    """
    Make and return the ASGI app.
    """
    return base.make_asgi_app(main)
